<?php
/**
 * @package Joomla.Site
 * @subpackage mod_simplybook
 * @copyright Copyright (c) Simplybook Inc. All right reserved.
 * @license GNU GPL 2 or later
 */

defined('_JEXEC') or die;

global $wpSSWrap;
$wpSSWrap = new WpScriptStyleWrapper();


function sb_get_text(){
	global $simplybook_domain;
	$args = func_get_args();
	return call_user_func_array(array('JText', 'sprintf'), $args);
}

function sb_show_text(){
	global $simplybook_domain;
	$args = func_get_args();
	echo call_user_func_array(array('JText', 'sprintf'), $args);
}

function sb_text(){

}


function simplybook_init_process($do){
	global $simplybook_domain, $simplybook_cfg, $simplybook_plugin_dir;
	//$api_url = 	admin_url('admin-ajax.php')."?action=sb_api"; //TODO
	$api_url = JURI::base() . 'index.php?option=com_ajax&module=simplybook&format=json&method=req';

	if($do == 'show'){

		//get transliatons
		$tWrap = new TranslateWrapper();
		$translations_keys = $tWrap->getKeys();
		foreach($translations_keys as $key){
			JText::script($key);
		}

		// Register the script
		wp_register_script( $simplybook_domain.'_translation', plugins_url($simplybook_plugin_dir.'/js/locale.js') );
		wp_register_script( $simplybook_domain.'_flexible_timeline', plugins_url($simplybook_plugin_dir.'/js/flexible-timeline.js') );
		wp_register_script( $simplybook_domain.'_api_client', plugins_url($simplybook_plugin_dir.'/js/api-client.js') );
		wp_register_script( $simplybook_domain.'_api_model', plugins_url($simplybook_plugin_dir.'/js/api-model.js') );
		wp_register_script( $simplybook_domain.'_api_view', plugins_url($simplybook_plugin_dir.'/themes/'.$simplybook_cfg['template'].'/js/api-view.js') );

		wp_enqueue_script('jquery');
		//wp_enqueue_script('jquery-ui-core');
		//wp_enqueue_script('jquery-ui-dialog');
		//wp_enqueue_script('jquery-ui-datepicker');
		wp_register_script( 'jquery-ui', plugins_url($simplybook_plugin_dir.'/js/jquery-ui-1.9.2.custom.js') );
		wp_enqueue_script( 'jquery-ui', array('jquery') );

		wp_enqueue_script( $simplybook_domain.'_translation', array('jquery', 'jquery-ui-core', 'jquery-ui-datepicker') );
		wp_enqueue_script( $simplybook_domain.'_flexible_timeline', array('jquery', 'jquery-ui-core', 'jquery-ui-datepicker') );
		wp_enqueue_script( $simplybook_domain.'_api_client', array('jquery', 'jquery-ui-core', 'jquery-ui-datepicker') );
		wp_enqueue_script( $simplybook_domain.'_api_model', array('jquery', 'jquery-ui-core', 'jquery-ui-datepicker') );
		wp_enqueue_script( $simplybook_domain.'_api_view', array('jquery', 'jquery-ui-core', 'jquery-ui-datepicker') );

			//wp_localize_script( $simplybook_domain.'_translation', 'simplybook_translation', $translations_keys );
		wp_localize_script( $simplybook_domain.'_translation', 'simplybook_api_url', $api_url );
		wp_localize_script( $simplybook_domain.'_translation', 'simplybook_stripe_status', (((int)@$simplybook_cfg['stripe_status'])?'1':'0') );
		wp_localize_script( $simplybook_domain.'_translation', 'simplybook_paypal_status', (((int)@$simplybook_cfg['paypal_status'])?'1':'0') );
		wp_localize_script( $simplybook_domain.'_translation', 'simplybook_adyen_status', (((int)@$simplybook_cfg['adyen_status'])?'1':'0') );
		wp_localize_script( $simplybook_domain.'_translation', 'simplybook_paymentwall_status', (((int)@$simplybook_cfg['paymentwall_status'])?$simplybook_cfg['paymentwall_status']:'0') );
		wp_localize_script( $simplybook_domain.'_translation', 'simplybook_url', '//' . substr(@$simplybook_cfg['url'] , strpos(@$simplybook_cfg['url'], '.')+1) );  //if api_url = user-api.simplybook.me than return //simplybook.me


		if((int)@$simplybook_cfg['stripe_status']){
			wp_enqueue_script( 'stripe-checkout', '//checkout.stripe.com/checkout.js', array( 'jquery' ));

			wp_localize_script( $simplybook_domain.'_translation', 'simplybook_stripe_key', @$simplybook_cfg['stripe_api_key'] );
			wp_localize_script( $simplybook_domain.'_translation', 'simplybook_stripe_name', @$simplybook_cfg['stripe_name'] );
			wp_localize_script( $simplybook_domain.'_translation', 'simplybook_stripe_description', @$simplybook_cfg['stripe_description'] );
		}

		if((int)@$simplybook_cfg['paymentwall_status']){
			wp_enqueue_script( 'paymentwall-brick', 'https://api.paymentwall.com/brick/brick.1.4.js', array( 'jquery' ));
			wp_enqueue_script( 'paymentwall-class', plugins_url($simplybook_plugin_dir.'/js/paymentwall.js'), array( 'jquery' )) ;
			wp_enqueue_style('paypal-checkout-style', plugins_url($simplybook_plugin_dir.'/css/paymentwall.css') );

			wp_localize_script( $simplybook_domain.'_translation', 'simplybook_paymentwall_key', @$simplybook_cfg['paymentwall_api_key'] );
			//wp_localize_script( $simplybook_domain.'_translation', 'simplybook_paymentwall_name', @$simplybook_cfg['paymentwall_name'] );
			//wp_localize_script( $simplybook_domain.'_translation', 'simplybook_paymentwall_description', @$simplybook_cfg['paymentwall_description'] );
		}

		if((int)@$simplybook_cfg['paypal_status']){
			wp_enqueue_script( 'paypal-checkout', plugins_url($simplybook_plugin_dir.'/js/paypal.js'), array( 'jquery' )) ;
			wp_enqueue_style('paypal-checkout-style', plugins_url($simplybook_plugin_dir.'/css/paypal.css') );

			wp_localize_script( $simplybook_domain.'_translation', 'simplybook_paypal_url', @$simplybook_cfg['paypal_url'] );
			wp_localize_script( $simplybook_domain.'_translation', 'simplybook_paypal_account', @$simplybook_cfg['paypal_account'] );
		}

		if((int)@$simplybook_cfg['adyen_status']){
			wp_enqueue_script( 'adyen-checkout', plugins_url($simplybook_plugin_dir.'/js/adyen.js'), array( 'jquery' )) ;
			wp_enqueue_style('adyen-checkout-style', plugins_url($simplybook_plugin_dir.'/css/adyen.css') );

			wp_localize_script( $simplybook_domain.'_translation', 'simplybook_adyen_mode', @$simplybook_cfg['adyen_mode'] );
			//wp_localize_script( $simplybook_domain.'_translation', 'simplybook_paypal_account', @$simplybook_cfg['paypal_account'] );
		}

		$simplybook_params = (array)simplybook_get_api(
			'getCompanyParams',
			array(
				'time_format',
				'monday_is_first_day',
				'show_booking_page_in_client_timezone',
				'require_fields',
				'fixed_country_prefix',
				'changable_prefix_by_client',
				'allow_delay_payment',
				'user_public_timeline_type',
				'cancelation_policy_label',
				'cancelation_policy_text'
			)
		);

		wp_localize_script( $simplybook_domain.'_translation', 'simplybook_params', $simplybook_params);

		//wp_enqueue_style("wp-jquery-ui-dialog");
		wp_register_style( $simplybook_domain.'_style', plugins_url($simplybook_plugin_dir.'/themes/'.$simplybook_cfg['template'].'/css/style.css') );
		wp_enqueue_style( $simplybook_domain.'_style' );

		wp_register_style( $simplybook_domain.'_flexible_timeline', plugins_url($simplybook_plugin_dir.'/css/flexible-timeline.css') );
		wp_enqueue_style( $simplybook_domain.'_flexible_timeline' );

		$minify = function($str){
			return trim(preg_replace('/[[:^print:]]/', '', $str));
		};
		$custom_css = implode( "\n", array_map( $minify, explode( "\n", $simplybook_cfg['custom_css'] ) ) );
		$custom_css = preg_replace('/^\s+|\n|\r|\t|\s+$/m', '', $custom_css); //remove  all whitespace and line-breaks;

		wp_add_inline_style( $simplybook_domain.'_style', $custom_css );
		wp_enqueue_style('jquery-style', plugins_url($simplybook_plugin_dir.'/css/jquery-ui.css') );
	}

	$content = '';
	include SIMPLYBOOK_DIR . '/base/controller.php';
	return $content;
}

function simplybook_api_action(){
	global $simplybook_cfg;

	$map = array(
		'paymentwall_' => array( 'paymentwall_api', @$simplybook_cfg['paymentwall_status'] ),
		'adyen_' => array( 'adyen_api', @$simplybook_cfg['adyen_status'] ),
		'stripe_' => array( 'stripe_api', @$simplybook_cfg['stripe_status'] ),
		'paypal_' => array( 'paypal_api',@$simplybook_cfg['paypal_status'] )
	);

	foreach($map as $key=>$item) {
		list($api_name, $api_status) = $item;

		if ( strpos( @$_REQUEST['apimethod'], $key ) !== false && $api_status ) {
			$_REQUEST['apimethod'] = str_replace( $key, '', $_REQUEST['apimethod'] );
			simplybook_init_process( $api_name );
			return;
		}
	}
	simplybook_init_process('api');
}

function simplybook_clear_cache(){
	global $simplybook_cfg;

	foreach($simplybook_cfg['cached_methods'] as $method){
		delete_transient( 'simplybook_'.$method );
	}
}

function simplybook_get_theme_list(){
	$directory = SIMPLYBOOK_DIR.'/base/themes/';
	$scanned_directory = array_diff(scandir($directory), array( '..', '.' ));
	$list = array();

	foreach($scanned_directory as $el){
		$list[] = array(
			'name' => $el,
			'dir' => SIMPLYBOOK_DIR.'/base/themes/'.$el,
			'url' => SIMPLYBOOK_URL.'/base/themes/'.$el
		);
	}
	return $list;
}

if (!function_exists('array_map_recursive')) {

	function array_map_recursive( $callback, $array ) {
		foreach ( $array as $key => $value ) {
			if ( is_array( $array[ $key ] ) ) {
				$array[ $key ] = array_map_recursive( $callback, $array[ $key ] );
			} else {
				$array[ $key ] = call_user_func( $callback, $array[ $key ] );
			}
		}
		return $array;
	}
}


function simplybook_get_api(){
	$args = func_get_args();
	$_REQUEST['apimethod'] = array_shift($args);
	$_REQUEST['params'] = $args;

	ob_start();
	simplybook_init_process('api');
	$out = ob_get_contents();
	ob_end_clean();

	//return $out;
	return json_decode($out);
}



function simplybook_save_log($file_name, $data, $append = true){
	$log_dir = SIMPLYBOOK_DIR.'/base/logs/';

	if($append){
		file_put_contents($log_dir.$file_name.'.txt', $data, FILE_APPEND | LOCK_EX );
	} else {
		file_put_contents($log_dir.$file_name.'.txt', $data );
	}

}


//EMULATE WP FUNCTIONS


function plugins_url($str){
	global $simplybook_plugin_dir;
	return str_replace($simplybook_plugin_dir,SIMPLYBOOK_URL.'/base', $str);
}

function sanitize_text_field($str){
	return sbSanitize($str);
}

function esc_attr($str){
	return htmlspecialchars($str);
}

function wp_register_script($name, $path){
	global $wpSSWrap;
	$wpSSWrap->registerScript($name, $path);
}

function wp_register_style($name, $path){
	global $wpSSWrap;
	$wpSSWrap->registerStyle($name, $path);
}

function wp_enqueue_script($name, $path = null, $after = null){
	global $wpSSWrap;
	if( count(func_get_args()) == 2 ){
		$after = $path;
		$path = null;
	}
	if($path != null){
		wp_register_script($name, $path);
	}
	$wpSSWrap->enqueueScript($name, $after);
}

function wp_enqueue_style($name, $path = null, $after = null){
	global $wpSSWrap;

	if($path != null){
		wp_register_style($name, $path);
	}
	$wpSSWrap->enqueueStyle($name, $after);
}

function wp_localize_script($name, $paramName, $value){
	global $wpSSWrap;
	$wpSSWrap->localizeScript($paramName, $value);
}

function wp_add_inline_style($name, $css){
	global $wpSSWrap;
	$wpSSWrap->addInlineStyle($css);
}

function set_transient($name, $data, $timeToLive){
	$cache = JFactory::getCache('mod_simplybook', '');
	$cache->setCaching(true);
	$cache->setLifeTime( 365*24*3600 );

	$cache->store($data, $name);
	$cache->store(time() + (int)$timeToLive, $name . '_lifetime');
}

function get_transient($name){
	$cache = JFactory::getCache('mod_simplybook', '');
	$cache->setCaching(true);
	$cache->setLifeTime( 365*24*3600 );

	$lifetime = $cache->get($name . '_lifetime');

	if( !empty($lifetime) && time()<$lifetime ){
		$output = $cache->get($name);

		if (!empty($output)) {
			return $output;
		} else {
			return false;
		}
	} else {
		return false;
	}
}

function delete_transient($name){
	$cache = JFactory::getCache('mod_simplybook', '');
	$cache->setCaching(true);
	$cache->setLifeTime( 365*24*3600 );
	$cache->remove($name);
	$cache->remove($name . '_lifetime');
}


//Other additional functions

function sbCleanInput($input) {

	$search = array(
		'@<script[^>]*?>.*?</script>@si',   // Strip out javascript
		'@<[\/\!]*?[^<>]*?>@si',            // Strip out HTML tags
		'@<style[^>]*?>.*?</style>@siU',    // Strip style tags properly
		'@<![\s\S]*?--[ \t\n\r]*>@'         // Strip multi-line comments
	);

	$output = preg_replace($search, '', $input);
	return $output;
}

function sbSanitize($input) {
	$output = null;
	if (is_array($input)) {
		foreach($input as $var=>$val) {
			$output[$var] = sbSanitize($val);
		}
	}
	else {
		if (get_magic_quotes_gpc()) {
			$input = stripslashes($input);
		}
		$input  = sbCleanInput($input);
		$output = sbMysqlEscapeMimic($input);
	}
	return $output;
}

function sbMysqlEscapeMimic($inp) {
	if(is_array($inp))
		return array_map(__METHOD__, $inp);

	if(!empty($inp) && is_string($inp)) {
		return str_replace(array('\\', "\0", "\n", "\r", "'", '"', "\x1a"), array('\\\\', '\\0', '\\n', '\\r', "\\'", '\\"', '\\Z'), $inp);
	}

	return $inp;
}


function _is_curl_installed() {
	if  (in_array  ('curl', get_loaded_extensions())) {
		return true;
	}
	else {
		return false;
	}
}

function curl_load($url){
	curl_setopt($ch=curl_init(), CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	$response = curl_exec($ch);
	curl_close($ch);
	return $response;
}



///////////////////////////////////////////////////

if(isset($_REQUEST['apimethod']) &&  $_REQUEST['apimethod'] == 'clearCache'){
	simplybook_clear_cache();
}