<?php
/**
 * @package Joomla.Site
 * @subpackage mod_simplybook
 * @copyright Copyright (c) Simplybook Inc. All right reserved.
 * @license GNU GPL
 */


defined('_JEXEC') or die;
@session_start();


class ConfigWrapper {
	protected $params = null;

	public function getParams() {
		if($this->params == null) {
			$module       = JModuleHelper::getModule( 'mod_simplybook' );
			$this->params = json_decode( $module->params, true );
		}
		return $this->params;
	}
}

class TranslateWrapper {
	protected $keys = array();

	public function __construct() {
		$this->keys = array(
			'JANUARY', 'FEBRUARY', 'MARCH', 'APRIL', 'MAY', 'JUNE', 'JULY', 'AUGUST', 'SEPTEMBER', 'OCTOBER', 'NOVEMBER', 'DECEMBER',
			'SUN', 'MON', 'TUE', 'WED', 'THU', 'FRI', 'SAT',
			'SB_VIEW_NODESC', 'SB_VIEW_SELECT', 'SB_VIEW_DURATION', 'SB_VIEW_PRICE', 'SB_VIEW_PHONE', 'SB_VIEW_EMAIL', 'SB_VIEW_DAY',
			'SB_VIEW_LOCATION', 'SB_VIEW_CATEGORY', 'SB_VIEW_SERVICE', 'SB_VIEW_PROVIDER', 'SB_VIEW_DATETIME', 'SB_VIEW_PROMOCODE',
			'SB_VIEW_BOOKDELETED', 'SB_VIEW_BOOKRESERVED_NEEDVER', 'SB_VIEW_BOOKRESERVED', 'SB_VIEW_NOPAYMSYSTEMS', 'SB_VIEW_PAY',
			'SB_VIEW_BOOKRESERVED_NEEDCONF', 'SB_VIEW_PAYMERROR'
		);
	}

	public function getKeys(){
		return $this->keys;
	}
}

class WpScriptStyleWrapper{
	protected $doc;
	protected $registeredScripts = array();
	protected $registeredStyles = array();

	protected $enqueueScriptsStack = array();

	public function __construct() {


		$this->doc = JFactory::getDocument();
	}

	public function registerScript($name, $path){
		$this->registeredScripts[$name] = $path;
	}

	public function registerStyle($name, $path){
		$this->registeredStyles[$name] = $path;
	}

	public function enqueueScript($name, $after){ //TODO: after
		if($name == 'jquery'){
			//JHtml::_('jquery.ui');
			JHtml::_('jquery.framework');
			//$this->enqueueScriptsStack['jquery'] = null;

		} elseif (strpos($name, 'jquery-ui-') !== false){
			//$this->enqueueScriptsStack[$name] = null;
			$name = str_replace('jquery-ui-', '',$name);
			JHtml::_('jquery.ui', array($name));
		} else{
			$this->doc->addScript($this->registeredScripts[$name] );
		}
	}

	public function enqueueStyle($name, $after){  //TODO: after
		$this->doc->addStyleSheet( $this->registeredStyles[$name] );
	}

	public function localizeScript($paramName, $value){
		$this->doc->addScriptDeclaration("var {$paramName} = ".json_encode($value).";\n");
	}

	public function addInlineStyle($css){
		$this->doc->addStyleDeclaration($css);
	}

	protected function array_insert(&$array, $position, $insert)
	{
		if (is_int($position)) {
			array_splice($array, $position, 0, $insert);
		} else {
			$pos   = array_search($position, array_keys($array));
			$array = array_merge(
				array_slice($array, 0, $pos),
				$insert,
				array_slice($array, $pos)
			);
		}
	}
}


class ModSimplybook{

	protected $domain = 'simplybook_me';
	protected $plugin_dir;
	protected $cached_methods = array('available_methods', 'company_timezone', 'getUnitList', 'getEventList', 'getCategoriesList', 'getLocationsList', 'getAnyUnitData', 'getCompanyParam', 'getCompanyParams', /*'getPluginStatuses',*/ 'getAdditionalFields', 'getCountryPhoneCodes', 'getBookingCart');
	protected $cfg;

	public function __construct() {
		$this->plugin_dir = __DIR__;
		$configWrapper = new ConfigWrapper();
		$this->cfg = $configWrapper->getParams();

		$this->init();
	}

	protected function init(){
		$module = JModuleHelper::getModule( 'mod_simplybook' );
		define("SIMPLYBOOK_DIR",  $this->plugin_dir);
		define("SIMPLYBOOK_URL",  JURI::base().'modules/'.$module->module);
		define("HOUR_IN_SECONDS",  3600);

		global $simplybook_domain, $simplybook_plugin_dir, $simplybook_cfg;

		$simplybook_domain = $this->domain;
		$simplybook_plugin_dir = $this->plugin_dir;
		$simplybook_cfg = $this->cfg;
		$simplybook_cfg['cached_methods'] = $this->cached_methods;

		include SIMPLYBOOK_DIR.'/base/simplybook.php';
	}

}

$simplybookClass = new ModSimplybook();

class ModSimplybookHelper{

	public static function reqAjax(){
		error_reporting(E_ERROR); //hide warnings

		ob_start();
		simplybook_api_action();
		$out = ob_get_contents();
		ob_end_clean();
		return json_decode($out);
	}
}

if($_REQUEST['option'] != 'com_ajax'){
	error_reporting(E_ERROR); //hide warnings
	echo simplybook_init_process('show');

}
